# pyright: reportUnusedImport=false
import struct
from typing import Optional, Self, Sequence
from .. import abcs
from ..core import Request, serialize_bytes_to
_bytes = bytes | bytearray | memoryview
def invoke_after_msg(*, msg_id: int, query: _bytes) -> Request[_bytes]:
    _buffer = bytearray(b'-7\x9f\xcb')
    _buffer += struct.pack('<q', msg_id)
    _buffer += query
    return Request(b'' + _buffer)
def invoke_after_msgs(*, msg_ids: Sequence[int], query: _bytes) -> Request[_bytes]:
    _buffer = bytearray(b'\xf0\xb4\xc4=')
    _buffer += struct.pack('<ii', 0x1cb5c415, len(msg_ids))
    _buffer += struct.pack(f'<{len(msg_ids)}q', *msg_ids)
    _buffer += query
    return Request(b'' + _buffer)
def init_connection(*, api_id: int, device_model: str, system_version: str, app_version: str, system_lang_code: str, lang_pack: str, lang_code: str, proxy: Optional[abcs.InputClientProxy], params: Optional[abcs.JsonValue], query: _bytes) -> Request[_bytes]:
    _buffer = bytearray(b'\xa9^\xcd\xc1')
    flags = (0 if proxy is None else 1) | (0 if params is None else 2)
    _buffer += struct.pack('<Ii', flags, api_id)
    serialize_bytes_to(_buffer, device_model.encode('utf-8'))
    serialize_bytes_to(_buffer, system_version.encode('utf-8'))
    serialize_bytes_to(_buffer, app_version.encode('utf-8'))
    serialize_bytes_to(_buffer, system_lang_code.encode('utf-8'))
    serialize_bytes_to(_buffer, lang_pack.encode('utf-8'))
    serialize_bytes_to(_buffer, lang_code.encode('utf-8'))
    if proxy is not None:
      proxy._write_boxed_to(_buffer)
    if params is not None:
      params._write_boxed_to(_buffer)
    _buffer += query
    return Request(b'' + _buffer)
def invoke_with_layer(*, layer: int, query: _bytes) -> Request[_bytes]:
    _buffer = bytearray(b'\r\r\x9b\xda')
    _buffer += struct.pack('<i', layer)
    _buffer += query
    return Request(b'' + _buffer)
def invoke_without_updates(*, query: _bytes) -> Request[_bytes]:
    _buffer = bytearray(b'\xb7Y\x94\xbf')
    _buffer += query
    return Request(b'' + _buffer)
def invoke_with_messages_range(*, range: abcs.MessageRange, query: _bytes) -> Request[_bytes]:
    _buffer = bytearray(b'\xf2uR6')
    range._write_boxed_to(_buffer)
    _buffer += query
    return Request(b'' + _buffer)
def invoke_with_takeout(*, takeout_id: int, query: _bytes) -> Request[_bytes]:
    _buffer = bytearray(b'.\xfd\xa9\xac')
    _buffer += struct.pack('<q', takeout_id)
    _buffer += query
    return Request(b'' + _buffer)
